type Nullable<T> = T | null | undefined
export declare namespace khangul {
    abstract class RemovePolicy {
        private constructor();
        static get DEFAULT(): khangul.RemovePolicy & {
            get name(): "DEFAULT";
            get ordinal(): 0;
        };
        static get REFORMAT_ON_DELETE(): khangul.RemovePolicy & {
            get name(): "REFORMAT_ON_DELETE";
            get ordinal(): 1;
        };
        static values(): Array<khangul.RemovePolicy>;
        static valueOf(value: string): khangul.RemovePolicy;
        get name(): "DEFAULT" | "REFORMAT_ON_DELETE";
        get ordinal(): 0 | 1;
    }
    class HangulContext {
        constructor(initialPhrase?: string, removePolicy?: khangul.RemovePolicy);
        appendLetter(letter: string): void;
        removeLastLetter(): void;
        static deleteAtCaret$default($this: khangul.HangulContext, count: number, to?: number): string;
        getValue(): string;
    }
}
export as namespace khangul;