(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', './kotlin-kotlin-stdlib-js-ir.js', './kotlin-codepoints-parent-kotlin-codepoints.js'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('./kotlin-kotlin-stdlib-js-ir.js'), require('./kotlin-codepoints-parent-kotlin-codepoints.js'));
  else {
    if (typeof this['kotlin-kotlin-stdlib-js-ir'] === 'undefined') {
      throw new Error("Error loading module 'khangul'. Its dependency 'kotlin-kotlin-stdlib-js-ir' was not found. Please, check whether 'kotlin-kotlin-stdlib-js-ir' is loaded prior to 'khangul'.");
    }
    if (typeof this['kotlin-codepoints-parent-kotlin-codepoints'] === 'undefined') {
      throw new Error("Error loading module 'khangul'. Its dependency 'kotlin-codepoints-parent-kotlin-codepoints' was not found. Please, check whether 'kotlin-codepoints-parent-kotlin-codepoints' is loaded prior to 'khangul'.");
    }
    root.khangul = factory(typeof khangul === 'undefined' ? {} : khangul, this['kotlin-kotlin-stdlib-js-ir'], this['kotlin-codepoints-parent-kotlin-codepoints']);
  }
}(this, function (_, kotlin_kotlin, kotlin_kotlin_codepoints_parent_kotlin_codepoints) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var THROW_ISE = kotlin_kotlin.$_$.z;
  var Unit_getInstance = kotlin_kotlin.$_$.g;
  var Enum = kotlin_kotlin.$_$.y;
  var protoOf = kotlin_kotlin.$_$.r;
  var defineProp = kotlin_kotlin.$_$.m;
  var classMeta = kotlin_kotlin.$_$.l;
  var VOID = kotlin_kotlin.$_$.a1;
  var setMetadataFor = kotlin_kotlin.$_$.s;
  var charSequenceLength = kotlin_kotlin.$_$.k;
  var charSequenceGet = kotlin_kotlin.$_$.j;
  var Char__toInt_impl_vasixd = kotlin_kotlin.$_$.e;
  var dropLast = kotlin_kotlin.$_$.v;
  var toString = kotlin_kotlin.$_$.f;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.d;
  var Char = kotlin_kotlin.$_$.x;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.a;
  var copyToArray = kotlin_kotlin.$_$.h;
  var toString_0 = kotlin_kotlin.$_$.t;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.c;
  var objectMeta = kotlin_kotlin.$_$.q;
  var indexOf = kotlin_kotlin.$_$.i;
  var numberRangeToNumber = kotlin_kotlin.$_$.n;
  var numberToInt = kotlin_kotlin.$_$.p;
  var until = kotlin_kotlin.$_$.u;
  var slice = kotlin_kotlin.$_$.w;
  var StringBuilder_init_$Create$ = kotlin_kotlin.$_$.b;
  var appendCodePoint = kotlin_kotlin_codepoints_parent_kotlin_codepoints.$_$.a;
  //endregion
  //region block: pre-declaration
  setMetadataFor(RemovePolicy, 'RemovePolicy', classMeta, Enum);
  setMetadataFor(HangulContext, 'HangulContext', classMeta);
  setMetadataFor(HangulDefinition, 'HangulDefinition', objectMeta);
  //endregion
  var RemovePolicy_DEFAULT_instance;
  var RemovePolicy_REFORMAT_ON_DELETE_instance;
  function values() {
    return [RemovePolicy_DEFAULT_getInstance(), RemovePolicy_REFORMAT_ON_DELETE_getInstance()];
  }
  function valueOf(value) {
    switch (value) {
      case 'DEFAULT':
        return RemovePolicy_DEFAULT_getInstance();
      case 'REFORMAT_ON_DELETE':
        return RemovePolicy_REFORMAT_ON_DELETE_getInstance();
      default:
        RemovePolicy_initEntries();
        THROW_ISE();
        break;
    }
  }
  var RemovePolicy_entriesInitialized;
  function RemovePolicy_initEntries() {
    if (RemovePolicy_entriesInitialized)
      return Unit_getInstance();
    RemovePolicy_entriesInitialized = true;
    RemovePolicy_DEFAULT_instance = new RemovePolicy('DEFAULT', 0);
    RemovePolicy_REFORMAT_ON_DELETE_instance = new RemovePolicy('REFORMAT_ON_DELETE', 1);
  }
  function RemovePolicy(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  defineProp(protoOf(RemovePolicy), 'name', protoOf(RemovePolicy).g2);
  defineProp(protoOf(RemovePolicy), 'ordinal', protoOf(RemovePolicy).h2);
  function insertAtCaret($this, value) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var tmp = $this;
    var tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    var tmp0_substring = $this.k3_1;
    var tmp$ret$0;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$0 = tmp0_substring;
    tmp$ret$1 = tmp$ret$0.substring(0, selectionStart);
    var tmp_0 = tmp$ret$1 + value;
    var tmp$ret$3;
    // Inline function 'kotlin.text.substring' call
    var tmp1_substring = $this.k3_1;
    var tmp$ret$2;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$2 = tmp1_substring;
    tmp$ret$3 = tmp$ret$2.substring(selectionEnd);
    tmp.k3_1 = tmp_0 + tmp$ret$3;
    $this.l3_1 = $this.k3_1.length;
  }
  function deleteAtCaret($this, count, to) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var contentLength = $this.k3_1.length;
    var tmp$ret$0;
    // Inline function 'kotlin.math.min' call
    tmp$ret$0 = Math.min(count, selectionStart);
    var deleteFrom = tmp$ret$0;
    var deleteTo = (selectionEnd + to | 0) > contentLength ? contentLength - selectionEnd | 0 : to;
    var tmp$ret$2;
    // Inline function 'kotlin.text.substring' call
    var tmp0_substring = $this.k3_1;
    var tmp1_substring = selectionStart - deleteFrom | 0;
    var tmp2_substring = selectionEnd + deleteTo | 0;
    var tmp$ret$1;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$1 = tmp0_substring;
    tmp$ret$2 = tmp$ret$1.substring(tmp1_substring, tmp2_substring);
    var deleted = tmp$ret$2;
    var tmp = $this;
    var tmp$ret$4;
    // Inline function 'kotlin.text.substring' call
    var tmp3_substring = $this.k3_1;
    var tmp4_substring = selectionStart - deleteFrom | 0;
    var tmp$ret$3;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$3 = tmp3_substring;
    tmp$ret$4 = tmp$ret$3.substring(0, tmp4_substring);
    var tmp_0 = tmp$ret$4;
    var tmp$ret$6;
    // Inline function 'kotlin.text.substring' call
    var tmp5_substring = $this.k3_1;
    var tmp6_substring = selectionEnd + deleteTo | 0;
    var tmp$ret$5;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$5 = tmp5_substring;
    tmp$ret$6 = tmp$ret$5.substring(tmp6_substring);
    tmp.k3_1 = tmp_0 + tmp$ret$6;
    setCaretPosition($this, selectionStart - deleteFrom | 0);
    return deleted;
  }
  function deleteAtCaret$default($this, count, to, $super) {
    to = to === VOID ? 0 : to;
    return deleteAtCaret($this, count, to);
  }
  function setCaretPosition($this, position) {
    $this.l3_1 = position;
  }
  function getSelectionEnd($this) {
    return $this.l3_1;
  }
  function getSelectionStart($this) {
    return $this.l3_1;
  }
  function HangulContext(initialPhrase, removePolicy) {
    initialPhrase = initialPhrase === VOID ? '' : initialPhrase;
    removePolicy = removePolicy === VOID ? RemovePolicy_DEFAULT_getInstance() : removePolicy;
    this.j3_1 = removePolicy;
    this.k3_1 = initialPhrase;
    this.l3_1 = initialPhrase.length;
  }
  protoOf(HangulContext).appendLetter = function (letter) {
    insertAtCaret(this, letter);
    var deleted = deleteAtCaret$default(this, 2);
    insertAtCaret(this, composeHangul(deleted));
  };
  protoOf(HangulContext).removeLastLetter = function () {
    var deleted = deleteAtCaret$default(this, 1);
    var tmp;
    var tmp$ret$0;
    // Inline function 'kotlin.text.isNotEmpty' call
    var tmp0_isNotEmpty = deleted;
    tmp$ret$0 = charSequenceLength(tmp0_isNotEmpty) > 0;
    if (tmp$ret$0) {
      var tmp$ret$1;
      // Inline function 'kotlin.code' call
      var tmp1__get_code__adl84j = charSequenceGet(deleted, 0);
      tmp$ret$1 = Char__toInt_impl_vasixd(tmp1__get_code__adl84j);
      var containsArg = tmp$ret$1;
      tmp = 56320 <= containsArg ? containsArg <= 57343 : false;
    } else {
      tmp = false;
    }
    if (tmp) {
      deleted = deleteAtCaret$default(this, 1) + deleted;
    }
    var decomposed = decomposeHangul(deleted);
    if (decomposed.length > 1) {
      var tmp0_subject = this.j3_1;
      var tmp0 = tmp0_subject.f2_1;
      if (tmp0 === 0) {
        insertAtCaret(this, composeHangul(dropLast(decomposed, 1)));
      } else if (tmp0 === 1) {
        // Inline function 'kotlin.text.forEach' call
        var tmp2_forEach = dropLast(decomposed, 1);
        var indexedObject = tmp2_forEach;
        var inductionVariable = 0;
        var last = indexedObject.length;
        while (inductionVariable < last) {
          var element = charSequenceGet(indexedObject, inductionVariable);
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'khangul.HangulContext.removeLastLetter.<anonymous>' call
          this.appendLetter(toString(element));
        }
      }
    }
  };
  protoOf(HangulContext).getValue = function () {
    return this.k3_1;
  };
  function RemovePolicy_DEFAULT_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_DEFAULT_instance;
  }
  function RemovePolicy_REFORMAT_ON_DELETE_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_REFORMAT_ON_DELETE_instance;
  }
  function HangulDefinition() {
    HangulDefinition_instance = this;
    var tmp = this;
    var tmp$ret$2;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$1;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$0;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$0 = [new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12600)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12611)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12617)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    tmp$ret$1 = tmp$ret$0;
    tmp$ret$2 = tmp$ret$1;
    tmp.m3_1 = tmp$ret$2;
    var tmp_0 = this;
    var tmp$ret$7;
    // Inline function 'kotlin.collections.toTypedArray' call
    var tmp$ret$6;
    // Inline function 'kotlin.collections.map' call
    var tmp1_map = this.m3_1;
    var tmp$ret$5;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo = ArrayList_init_$Create$(tmp1_map.length);
    var indexedObject = tmp1_map;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var item = indexedObject[inductionVariable].x_1;
      inductionVariable = inductionVariable + 1 | 0;
      var tmp$ret$4;
      // Inline function 'khangul.HangulDefinition.initialCodes.<anonymous>' call
      var tmp$ret$3;
      // Inline function 'kotlin.code' call
      tmp$ret$3 = Char__toInt_impl_vasixd(item);
      tmp$ret$4 = tmp$ret$3;
      tmp0_mapTo.f1(tmp$ret$4);
    }
    tmp$ret$5 = tmp0_mapTo;
    tmp$ret$6 = tmp$ret$5;
    var tmp2_toTypedArray = tmp$ret$6;
    tmp$ret$7 = copyToArray(tmp2_toTypedArray);
    tmp_0.n3_1 = tmp$ret$7;
    var tmp_1 = this;
    var tmp$ret$10;
    // Inline function 'kotlin.arrayOf' call
    var tmp0_arrayOf = [new Char(_Char___init__impl__6a9atx(0)), new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12595)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12597)), new Char(_Char___init__impl__6a9atx(12598)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12602)), new Char(_Char___init__impl__6a9atx(12603)), new Char(_Char___init__impl__6a9atx(12604)), new Char(_Char___init__impl__6a9atx(12605)), new Char(_Char___init__impl__6a9atx(12606)), new Char(_Char___init__impl__6a9atx(12607)), new Char(_Char___init__impl__6a9atx(12608)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12612)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    var tmp$ret$9;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$8;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$8 = tmp0_arrayOf;
    tmp$ret$9 = tmp$ret$8;
    tmp$ret$10 = tmp$ret$9;
    tmp_1.o3_1 = tmp$ret$10;
    var tmp_2 = this;
    var tmp$ret$15;
    // Inline function 'kotlin.collections.toTypedArray' call
    var tmp$ret$14;
    // Inline function 'kotlin.collections.map' call
    var tmp1_map_0 = this.o3_1;
    var tmp$ret$13;
    // Inline function 'kotlin.collections.mapTo' call
    var tmp0_mapTo_0 = ArrayList_init_$Create$(tmp1_map_0.length);
    var indexedObject_0 = tmp1_map_0;
    var inductionVariable_0 = 0;
    var last_0 = indexedObject_0.length;
    while (inductionVariable_0 < last_0) {
      var item_0 = indexedObject_0[inductionVariable_0].x_1;
      inductionVariable_0 = inductionVariable_0 + 1 | 0;
      var tmp$ret$12;
      // Inline function 'khangul.HangulDefinition.finaleCodes.<anonymous>' call
      var tmp$ret$11;
      // Inline function 'kotlin.code' call
      tmp$ret$11 = Char__toInt_impl_vasixd(item_0);
      tmp$ret$12 = tmp$ret$11;
      tmp0_mapTo_0.f1(tmp$ret$12);
    }
    tmp$ret$13 = tmp0_mapTo_0;
    tmp$ret$14 = tmp$ret$13;
    var tmp2_toTypedArray_0 = tmp$ret$14;
    tmp$ret$15 = copyToArray(tmp2_toTypedArray_0);
    tmp_2.p3_1 = tmp$ret$15;
    var tmp_3 = this;
    var tmp$ret$18;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$17;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$16;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$16 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 800, 801, 820, 0, 0, 1304, 1305, 1320, 0, 0, 1820];
    tmp$ret$17 = tmp$ret$16;
    tmp$ret$18 = tmp$ret$17;
    tmp_3.q3_1 = tmp$ret$18;
    var tmp_4 = this;
    var tmp$ret$21;
    // Inline function 'kotlin.arrayOf' call
    var tmp$ret$20;
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp$ret$19;
    // Inline function 'kotlin.js.asDynamic' call
    tmp$ret$19 = [0, 0, 0, 119, 0, 422, 427, 0, 0, 801, 816, 817, 819, 825, 826, 827, 0, 0, 1719, 0, 1919];
    tmp$ret$20 = tmp$ret$19;
    tmp$ret$21 = tmp$ret$20;
    tmp_4.r3_1 = tmp$ret$21;
    this.s3_1 = 44032;
    this.t3_1 = 12623;
    this.u3_1 = 21;
    this.v3_1 = 588;
    this.w3_1 = this.p3_1.length;
    this.x3_1 = this.n3_1.length;
    this.y3_1 = imul(imul(this.x3_1, 21), this.w3_1);
    // Inline function 'kotlin.require' call
    var tmp0_require = this.x3_1 === 19;
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp0_require) {
      var tmp$ret$22;
      // Inline function 'khangul.HangulDefinition.<anonymous>' call
      tmp$ret$22 = 'Initial count must be equal to 19';
      var message = tmp$ret$22;
      throw IllegalArgumentException_init_$Create$(toString_0(message));
    }
    // Inline function 'kotlin.require' call
    var tmp1_require = this.w3_1 === 28;
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp1_require) {
      var tmp$ret$23;
      // Inline function 'khangul.HangulDefinition.<anonymous>' call
      tmp$ret$23 = 'Finale count must be equal to 28';
      var message_0 = tmp$ret$23;
      throw IllegalArgumentException_init_$Create$(toString_0(message_0));
    }
  }
  var HangulDefinition_instance;
  function HangulDefinition_getInstance() {
    if (HangulDefinition_instance == null)
      new HangulDefinition();
    return HangulDefinition_instance;
  }
  function composeHangul(input) {
    var tmp$ret$0;
    // Inline function 'kotlin.text.isEmpty' call
    tmp$ret$0 = charSequenceLength(input) === 0;
    if (tmp$ret$0)
      return '';
    var tmp$ret$1;
    // Inline function 'kotlin.code' call
    var tmp0__get_code__88qj9g = charSequenceGet(input, 0);
    tmp$ret$1 = Char__toInt_impl_vasixd(tmp0__get_code__88qj9g);
    var syllableCode = tmp$ret$1;
    var result = fromCharCode(new Int32Array([syllableCode]));
    var inductionVariable = 1;
    var last = input.length;
    if (inductionVariable < last)
      $l$loop_4: do {
        var charIdx = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        var tmp$ret$2;
        // Inline function 'kotlin.code' call
        var tmp1__get_code__adl84j = charSequenceGet(input, charIdx);
        tmp$ret$2 = Char__toInt_impl_vasixd(tmp1__get_code__adl84j);
        var currentCode = tmp$ret$2;
        var initialCode = indexOf(HangulDefinition_getInstance().n3_1, syllableCode);
        HangulDefinition_getInstance();
        var vowelDiff = currentCode - 12623 | 0;
        if (!(initialCode === -1)) {
          var tmp;
          if (0 <= vowelDiff) {
            HangulDefinition_getInstance();
            tmp = vowelDiff < 21;
          } else {
            tmp = false;
          }
          if (tmp) {
            HangulDefinition_getInstance();
            var tmp_0 = initialCode;
            HangulDefinition_getInstance();
            syllableCode = 44032 + imul(imul(tmp_0, 21) + vowelDiff | 0, HangulDefinition_getInstance().w3_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        var tmp_1 = syllableCode;
        HangulDefinition_getInstance();
        var relativeSyllableCode = tmp_1 - 44032 | 0;
        var finalConsonant = relativeSyllableCode % HangulDefinition_getInstance().w3_1 | 0;
        if ((0 <= relativeSyllableCode ? relativeSyllableCode <= 11144 : false) ? finalConsonant === 0 : false) {
          var currentFinale = indexOf(HangulDefinition_getInstance().p3_1, currentCode);
          if (!(currentFinale === -1)) {
            syllableCode = syllableCode + currentFinale | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
          HangulDefinition_getInstance();
          var mediaVowelBase = (relativeSyllableCode % 588 | 0) / HangulDefinition_getInstance().w3_1 | 0;
          var tmp_2 = HangulDefinition_getInstance().q3_1;
          var tmp_3 = imul(mediaVowelBase, 100);
          HangulDefinition_getInstance();
          var doubledMedialVowel = indexOf(tmp_2, tmp_3 + (currentCode - 12623 | 0) | 0);
          if (doubledMedialVowel > 0) {
            syllableCode = syllableCode + imul(doubledMedialVowel - mediaVowelBase | 0, HangulDefinition_getInstance().w3_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        if ((0 <= relativeSyllableCode ? relativeSyllableCode < HangulDefinition_getInstance().y3_1 : false) ? !(finalConsonant === 0) : false) {
          var tmp_4;
          if (0 <= vowelDiff) {
            HangulDefinition_getInstance();
            tmp_4 = vowelDiff < 21;
          } else {
            tmp_4 = false;
          }
          if (tmp_4) {
            initialCode = indexOf(HangulDefinition_getInstance().n3_1, HangulDefinition_getInstance().p3_1[finalConsonant]);
            if (0 <= initialCode ? initialCode < HangulDefinition_getInstance().x3_1 : false) {
              result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode - finalConsonant | 0]));
              HangulDefinition_getInstance();
              var tmp_5 = initialCode;
              HangulDefinition_getInstance();
              syllableCode = 44032 + imul(imul(tmp_5, 21) + vowelDiff | 0, HangulDefinition_getInstance().w3_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
            if (finalConsonant < HangulDefinition_getInstance().r3_1.length ? !(HangulDefinition_getInstance().r3_1[finalConsonant] === 0) : false) {
              var tmp_6 = sliceExclusive(result, numberRangeToNumber(0, result.length));
              var tmp_7 = syllableCode - finalConsonant | 0;
              var tmp$ret$3;
              // Inline function 'kotlin.math.floor' call
              var tmp2_floor = HangulDefinition_getInstance().r3_1[finalConsonant] / 100.0;
              tmp$ret$3 = Math.floor(tmp2_floor);
              result = tmp_6 + fromCharCode(new Int32Array([tmp_7 + numberToInt(tmp$ret$3) | 0]));
              HangulDefinition_getInstance();
              var tmp_8 = indexOf(HangulDefinition_getInstance().n3_1, HangulDefinition_getInstance().p3_1[HangulDefinition_getInstance().r3_1[finalConsonant] % 100 | 0]);
              HangulDefinition_getInstance();
              syllableCode = 44032 + imul(imul(tmp_8, 21) + vowelDiff | 0, HangulDefinition_getInstance().w3_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
          }
          var doubledFinaleConsonant = indexOf(HangulDefinition_getInstance().r3_1, imul(finalConsonant, 100) + indexOf(HangulDefinition_getInstance().p3_1, currentCode) | 0);
          if (doubledFinaleConsonant > 0) {
            syllableCode = (syllableCode + doubledFinaleConsonant | 0) - finalConsonant | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        syllableCode = currentCode;
        result = result + fromCharCode(new Int32Array([currentCode]));
      }
       while (inductionVariable < last);
    return result;
  }
  function decomposeHangul(input) {
    var result = '';
    var indexedObject = input;
    var inductionVariable = 0;
    var last = indexedObject.length;
    $l$loop: while (inductionVariable < last) {
      var char = charSequenceGet(indexedObject, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      var tmp$ret$0;
      // Inline function 'kotlin.code' call
      tmp$ret$0 = Char__toInt_impl_vasixd(char);
      var charCode = tmp$ret$0;
      HangulDefinition_getInstance();
      var relativeCode = charCode - 44032 | 0;
      if (relativeCode < 0 ? true : relativeCode >= HangulDefinition_getInstance().y3_1) {
        result = result + new Char(char);
        continue $l$loop;
      }
      var tmp = HangulDefinition_getInstance().n3_1;
      var tmp$ret$1;
      // Inline function 'kotlin.math.floor' call
      HangulDefinition_getInstance();
      var tmp0_floor = relativeCode / 588;
      tmp$ret$1 = Math.floor(tmp0_floor);
      var initialCode = tmp[numberToInt(tmp$ret$1)];
      HangulDefinition_getInstance();
      HangulDefinition_getInstance();
      var syllable = 12623 + ((relativeCode % 588 | 0) / HangulDefinition_getInstance().w3_1 | 0) | 0;
      var finaleCode = HangulDefinition_getInstance().p3_1[relativeCode % HangulDefinition_getInstance().w3_1 | 0];
      result = result + fromCharCode(new Int32Array([initialCode, syllable]));
      if (!(finaleCode === 0)) {
        result = result + fromCharCode(new Int32Array([finaleCode]));
      }
    }
    return result;
  }
  function sliceExclusive(_this__u8e3s4, range) {
    return slice(_this__u8e3s4, until(range.p_1, range.q_1 - 2 | 0));
  }
  function fromCharCode(codePoints) {
    var builder = StringBuilder_init_$Create$(codePoints.length);
    var indexedObject = codePoints;
    var inductionVariable = 0;
    var last = indexedObject.length;
    while (inductionVariable < last) {
      var codePoint = indexedObject[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      appendCodePoint(builder, codePoint);
    }
    return builder.toString();
  }
  //region block: exports
  function $jsExportAll$(_) {
    var $khangul = _.khangul || (_.khangul = {});
    $khangul.RemovePolicy = RemovePolicy;
    $khangul.RemovePolicy.values = values;
    $khangul.RemovePolicy.valueOf = valueOf;
    defineProp($khangul.RemovePolicy, 'DEFAULT', RemovePolicy_DEFAULT_getInstance);
    defineProp($khangul.RemovePolicy, 'REFORMAT_ON_DELETE', RemovePolicy_REFORMAT_ON_DELETE_getInstance);
    $khangul.HangulContext = HangulContext;
    $khangul.HangulContext.deleteAtCaret$default = deleteAtCaret$default;
  }
  $jsExportAll$(_);
  //endregion
  return _;
}));

//# sourceMappingURL=khangul.js.map
